type exp = Var of string 
         | Lam of string*exp 
	 | Apply of exp * exp

exception BadExp
exception Unimplemented

let subst e1_in e2_for x = raise Unimplemented (* to be discussed *)

(* call by value *)
let rec interp_large e =
  match e with
   Var _ -> raise BadExp (* unbound variable *)
 | Lam _ -> e (* functions are values *)
 | Apply(e1,e2) ->
    let v1 = interp_large e1 in
    let v2 = interp_large e2 in
    match v1 with
      Lam(x,e3) -> interp_large (subst e3 v2 x)
     | _ -> failwith "impossible" (* why? *)

(* call by name *)
let rec interp_large2 e =
  match e with
   Var _ -> raise BadExp (* unbound variable *)
 | Lam _ -> e (* functions are values *)
 | Apply(e1,e2) ->
    let v1 = interp_large2 e1 in
    (* we used to evaluate e2 to v2 here *)
    match v1 with
      Lam(x,e3) -> interp_large2 (subst e3 e2 x)
     | _ -> failwith "impossible" (* why? *)
